import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { AzureTenantComponent } from './azuretenant/azuretenant.component';
import { AdminsubscriptionComponent } from './subscription/subscription.component';
import { AdminserviceprincipleComponent } from './serviceprincipal/serviceprincipal.component';
import { AdminresourcegroupComponent } from './resourcegroup/resourcegroup.component';
import { MSTResourcesComponent } from './mstresourcelist/mstresourcelist.component';
import { MstresourcepropertiesComponent } from './mstresourceproperties/mstresourceproperties.component';
import { MstdataresourcepropertiesComponent } from './mstresourcedataproperties/mstresourcedataproperties.component';
import { RouterModule } from '@angular/router';
import { MsalGuard } from '@azure/msal-angular';
import { MstconfigrolesComponent } from './mstconfigrolelist/mstconfigrolelist.component';
import { MstplaybookpropertiesComponent } from './mstconfigroleproperties/mstconfigroleproperties.component';
import { MstblueprintdetailsComponent } from './mstblueprintlist/mstblueprintlist.component';
import { MstblueprintComponent } from './mstblueprint/mstblueprint.component';
import { MstbluepritresourceComponent } from './mstblueprintresources/mstblueprintresources.component';
import { TenantComponent } from './tenantnavigation/tenantnavigation.component';
import { MasterComponent } from './mstnavigation/mstnavigation.component';
import { MstplaybooktabComponent } from './mstconfignavigation/mstconfignavigation.component';
import { MstblueprinttabComponent } from './mstblueprintnavigation/mstblueprintnavigation.component';
import { MatFormFieldModule } from '@angular/material/form-field';
import { JsonFormsModule } from '@jsonforms/angular';
import { JsonFormsAngularMaterialModule } from '@jsonforms/angular-material';
import { MatProgressSpinnerModule } from '@angular/material/progress-spinner';

@NgModule({
  declarations: [
    AzureTenantComponent,
    AdminsubscriptionComponent,
    AdminserviceprincipleComponent,
    AdminresourcegroupComponent,
    MSTResourcesComponent,
    MstresourcepropertiesComponent,
    MstdataresourcepropertiesComponent,
    MstconfigrolesComponent,
    MstplaybookpropertiesComponent,
    MstblueprintdetailsComponent,
    MstblueprintComponent,
    MstbluepritresourceComponent,
    TenantComponent,
    MasterComponent,
    MstplaybooktabComponent,
    MstblueprinttabComponent
  ],
  imports: [
    CommonModule,
    MatFormFieldModule,
    JsonFormsModule,
    JsonFormsAngularMaterialModule,
    MatProgressSpinnerModule,
    RouterModule.forChild([
      { path: "", redirectTo: "tenant", pathMatch: "full" },
      { path: 'tenant', component:AzureTenantComponent },
      { path: 'subscription', component:AdminsubscriptionComponent },
      { path: 'serviceprincipal', component:AdminserviceprincipleComponent },
      { path: 'resourcegroup', component:AdminresourcegroupComponent } ,
      { path: 'mstresourcelist', component:MSTResourcesComponent } ,
      { path: 'mstresourceproperties', component:MstresourcepropertiesComponent } ,
      { path: 'mstresourcedataproperties', component:MstdataresourcepropertiesComponent } ,
      { path: 'configrole', component:MstconfigrolesComponent },
      { path: 'playbookproperties', component:MstplaybookpropertiesComponent },
      { path: 'blueprintdetails', component:MstblueprintdetailsComponent },
      { path: 'blueprintform', component:MstblueprintComponent },
      { path: 'blueprintresource', component:MstbluepritresourceComponent }
  ])
]
})
export class AdministrationModule { }