import { Component, OnInit } from '@angular/core';
import { WebapiService } from '../../service/webapi.service';
import { ActivatedRoute, Router } from '@angular/router';
import { Log } from '../../model/project.model';
import { MsalService } from '@azure/msal-angular';
import { environment } from 'src/environments/environment';

@Component({
  selector: 'app-mstblueprintlist',
  templateUrl: './mstblueprintlist.component.html',
  styleUrls: ['./mstblueprintlist.component.css']
})
export class MstblueprintdetailsComponent implements OnInit {

  templateDetails: any;
  templateDetailsDataSource: any;
  errorlog: Log = new Log();
  isLoggedInUserAdmin: boolean = false;

  constructor(private webapiService: WebapiService, private _router: Router, private route: ActivatedRoute) { }

  ngOnInit(): void {
    this.errorlog.application = "Azap";
    this.errorlog.modulename = "Mstblueprintdetails - ngOnInit";
    this.errorlog.type = "Error";
    try {
      //let userRoles: string[] = this.authService.instance.getAllAccounts()[0].idTokenClaims.roles;

      //this.isLoggedInUserAdmin = (userRoles!=undefined) ? userRoles.indexOf(environment.adminRole) > -1: false;

      //if (this.isLoggedInUserAdmin) {
        this.getAllTemplates();
      //}
      //else {
      //  this._router.navigateByUrl('/home');
      //}
    } catch (error) {
      this.errorlog.remark = error.message + "-" + error.stack;
      this.webapiService.ErrorLogfn(this.errorlog);
    }
  }

  openReferenceArchitecture(imgname: string) {
    if (imgname != "") {
      $('.imgrefarchitect').attr('src', '/assets/images/architectimages/' + imgname);
    }
    else {
      $('.imgrefarchitect').attr('src', '/assets/images/notfound.png');
    }
    $('#RefernceArcitectModal').modal('show');
  }

  getAllTemplates() {
    this.errorlog.modulename = "Mstblueprintdetails - getAllTemplates";
    try {
      this.templateDetails = [];
      this.webapiService.getAllTemplateDetails('all').subscribe(res => {
        if (typeof res != 'undefined' && res.length > 0) {
          this.templateDetails = res;
          this.templateDetailsDataSource = res;
        }
        else if (typeof res != 'undefined' && res.length == 0) {
          this.templateDetails = [];
          this.templateDetailsDataSource = [];
        }
      }, (error) => {
        this.errorlog.remark = error;
        this.webapiService.ErrorLogfn(this.errorlog);
      });
    } catch (error) {
      this.errorlog.remark = error;
      this.webapiService.ErrorLogfn(this.errorlog);
    }
  }

  applyFilter(filterValue: string) {
    this.errorlog.modulename = "Mstblueprintdetails - applyFilter";
    try {
      filterValue = filterValue.trim(); // Remove whitespace
      filterValue = filterValue.toLowerCase();

      this.templateDetailsDataSource = this.templateDetails;
      this.templateDetailsDataSource = this.templateDetailsDataSource.filter(x => x.templatename.toLowerCase().includes(filterValue));

      if (filterValue.trim() === '') {
        this.templateDetailsDataSource = this.templateDetails;
      }
    } catch (error) {
      this.errorlog.remark = error.message + "-" + error.stack;
      this.webapiService.ErrorLogfn(this.errorlog);
    }
  }

  deleteblueprint(blueprintid: string) {
    this.webapiService.deleteblueprintdetails(blueprintid).subscribe(res => {
      this.getAllTemplates();
    }, (error) => {
      this.errorlog.remark = error;
      this.webapiService.ErrorLogfn(this.errorlog);
    });
  }

  createblueprint() {
    this._router.navigateByUrl('/administration/blueprintform');
  }

  editblueprint(blueprintid: string) {
    this.webapiService._commonblueprintedit.blueprintid = blueprintid;
    this._router.navigateByUrl('/administration/blueprintform');
  }
}