import { Component, OnInit } from '@angular/core';
import { WebapiService } from '../../service/webapi.service';
import { FormBuilder, Validators } from '@angular/forms';
import { Observable } from 'rxjs';
import { Project, projectEnvironment, replicateEnvironment, deleteEnvironment, EnvironmentDetails, Environment } from '../../model/project.model'
import { ActivatedRoute, Router } from '@angular/router';
import { stringify } from 'querystring';
import { RouterModule, Routes } from '@angular/router';

@Component({
  selector: 'app-mstblueprintnavigation',
  templateUrl: './mstblueprintnavigation.component.html',
  styleUrls: ['./mstblueprintnavigation.component.css']
})
export class MstblueprinttabComponent implements OnInit {

  navLinks: any[];
  activeLinkIndex = 0;

  constructor(private apiService: WebapiService, private formbulider: FormBuilder,
    private route: ActivatedRoute, private _router: Router) {
    this.navLinks = [
      {
        label: 'Blueprint List',
        link: '/administration/blueprintdetails',
        queryparams: '',
        index: 0
      }, {
        label: 'Create/Edit Blueprint',
        link: '/administration/blueprintform',
        queryparams: '',
        index: 1
      }, {
        label: 'Blueprint Resource',
        link: '/administration/blueprintresource',
        queryparams: '',
        index: 2
      }]
  }

  ngOnInit(): void {
    this._router.events.subscribe((res) => {
      this.activeLinkIndex = this.navLinks.indexOf(this.navLinks.find(tab => tab.link === '.' + this._router.url));
  });
  }

}
