import { Component, OnInit } from '@angular/core';
import { WebapiService } from '../../service/webapi.service';
import { FormBuilder } from '@angular/forms';
import { ActivatedRoute, Router } from '@angular/router';

@Component({
  selector: 'app-mstconfignavigation',
  templateUrl: './mstconfignavigation.component.html',
  styleUrls: ['./mstconfignavigation.component.css']
})
export class MstplaybooktabComponent implements OnInit {
  navLinks: any[];
  activeLinkIndex = 0;

  constructor(private apiService: WebapiService, private formbulider: FormBuilder,
    private route: ActivatedRoute, private _router: Router) {
    this.navLinks = [
      {
        label: 'Role',
        link: '/administration/configrole',
        queryparams: '',
        index: 0
      }, {
        label: 'Role Properties',
        link: '/administration/playbookproperties',
        queryparams: '',
        index: 1
      }]
  }

  ngOnInit(): void {
    this._router.events.subscribe((res) => {
      this.activeLinkIndex = this.navLinks.indexOf(this.navLinks.find(tab => tab.link === '.' + this._router.url));
  });
  }

}
