import { Component, OnInit } from '@angular/core';
import { WebapiService } from '../../service/webapi.service';
import { FormBuilder, Validators } from '@angular/forms';
import { ActivatedRoute, Router } from '@angular/router';

@Component({
  selector: 'app-mstnavigation',
  templateUrl: './mstnavigation.component.html',
  styleUrls: ['./mstnavigation.component.css']
})
export class MasterComponent implements OnInit {
  navLinks: any[];
  activeLinkIndex = 0;
  constructor(private apiService: WebapiService, private formbulider: FormBuilder,
    private route: ActivatedRoute, private _router: Router) {
    this.navLinks = [
      {
        label: 'Resource',
        link: '/administration/mstresourcelist',
        queryparams: '',
        index: 0
      }, {
        label: 'Resource Property',
        link: '/administration/mstresourceproperties',
        queryparams: '',
        index: 1
      },
      {
        label: 'Data Property',
        link: '/administration/mstresourcedataproperties',
        queryparams: '',
        index: 2
      }
    ];
  }

  ngOnInit(): void {
    this._router.events.subscribe((res) => {
      this.activeLinkIndex = this.navLinks.indexOf(this.navLinks.find(tab => tab.link === '.' + this._router.url));
  });
  }

}
