import { Component, OnInit } from '@angular/core';
import { FormBuilder } from '@angular/forms';
import { ActivatedRoute, Router } from '@angular/router';
import { WebapiService } from '../../service/webapi.service';

@Component({
  selector: 'app-tenantnavigation',
  templateUrl: './tenantnavigation.component.html',
  styleUrls: ['./tenantnavigation.component.css']
})
export class TenantComponent implements OnInit {

  navLinks: any[];
  activeLinkIndex = 0;
  constructor(private apiService: WebapiService, private formbulider: FormBuilder,
    private route: ActivatedRoute, private _router: Router) {
    this.navLinks = [
      {
        label: 'Tenant',
        link: '/administration/tenant',
        index: 0
      }, {
        label: 'Subscription',
        link: '/administration/subscription',
        index: 1
      }, {
        label: 'Service Principle',
        link: '/administration/serviceprincipal',
        index: 2
      },
      {
        label: 'Resource Group',
        link: '/administration/resourcegroup',
        index: 3
      }
    ];
  }
  ngOnInit(): void {
    this._router.events.subscribe((res) => {
      this.activeLinkIndex = this.navLinks.indexOf(this.navLinks.find(tab => tab.link === '.' + this._router.url));
    });
  }
}
