import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { RouterModule, Routes } from '@angular/router';
import { AppComponent } from './app.component';
import { ProjectComponent } from './infrastructure/projectnavigation/projectnavigation.component';
import { HomeComponent } from './home/home.component';
import { AzureTenantComponent } from './administration/azuretenant/azuretenant.component';
//import { DeploymentComponent } from './infrastructure/deployment/deployment.component';
//import { ResourcegroupComponent } from './infrastructure/resourcegroup/resourcegroup.component';
import { DashboardComponent } from './dashboard/dashboard.component';
//import { EnvironmentComponent  } from './infrastructure/environment/environment.component';
import { CreateProjectComponent } from './infrastructure/project/project.component';
//import { DeploymentconfigComponent } from './configuration/deployment/deployment.component';
//import { AssociationComponent } from './configuration/association/association.component';
//import { PlaybookComponent } from './configuration/playbook/playbook.component';
import { MSTResourcesComponent } from './administration/mstresourcelist/mstresourcelist.component';
//import { CreateprojectconfigComponent } from './configuration/project/project.component';
//import { InfrareviewComponent } from './infrastructure/review/review.component';
//import { ReviewconfigComponent } from './configuration/review/review.component';
//import { HostgroupComponent } from './configuration/hostgroup/hostgroup.component';
import { MstresourcepropertiesComponent } from './administration/mstresourceproperties/mstresourceproperties.component';
import {MasterComponent} from './administration/mstnavigation/mstnavigation.component';
import { MstblueprintComponent } from './administration/mstblueprint/mstblueprint.component';
//import { ResourcesComponent } from './infrastructure/resources/resources.component';
import { MstblueprintdetailsComponent } from './administration/mstblueprintlist/mstblueprintlist.component';
import { MstbluepritresourceComponent } from './administration/mstblueprintresources/mstblueprintresources.component';
import { MstblueprinttabComponent } from './administration/mstblueprintnavigation/mstblueprintnavigation.component';
import { MstplaybooktabComponent } from './administration/mstconfignavigation/mstconfignavigation.component';
import { MstplaybookpropertiesComponent } from './administration/mstconfigroleproperties/mstconfigroleproperties.component';
import { MstconfigrolesComponent } from './administration/mstconfigrolelist/mstconfigrolelist.component';
import { WelcomeComponent } from './welcome/welcome.component';
import { MsalGuard } from '@azure/msal-angular';
import { AdminsubscriptionComponent } from './administration/subscription/subscription.component';
import { AdminserviceprincipleComponent } from './administration/serviceprincipal/serviceprincipal.component';
import { AdminresourcegroupComponent } from './administration/resourcegroup/resourcegroup.component';
import { MstdataresourcepropertiesComponent } from './administration/mstresourcedataproperties/mstresourcedataproperties.component';
import { InfrastructureModule } from './infrastructure/infrastructure.module';
import { ConfigurationModule } from './configuration/configuration.module';
import { AdministrationModule } from './administration/administration.module';

const appRoutes: Routes = [
  { path: '', pathMatch: 'full', component: WelcomeComponent },
  { path: 'dashboard', component: DashboardComponent },
  //{ path: 'resourcegroup', component: ResourcegroupComponent },
  //{ path: 'resources', component: ResourcesComponent },
  { path: 'home', component:HomeComponent },
  { path: 'azuretenant', component:AzureTenantComponent },
  //{ path: 'deployment', component:DeploymentComponent },
  { path: 'infrastructure', loadChildren:()=> InfrastructureModule },
  { path: 'configuration', loadChildren:()=> ConfigurationModule },
  { path: 'administration', loadChildren:()=>AdministrationModule },
  //{ path: 'environment', component:EnvironmentComponent },
  //{ path: 'project', component:CreateProjectComponent },
  //{ path: 'deploymentconfig',component:DeploymentconfigComponent},
  //{ path: 'association',component:AssociationComponent},
  //{ path: 'playbook',component:PlaybookComponent},
  //{ path: 'masterresource', component: MSTResourcesComponent },
  //{ path: 'createprojectconfig', component:CreateprojectconfigComponent },
  //{ path: 'infrareview',component:InfrareviewComponent},
  //{ path: 'reviewconfig', component:ReviewconfigComponent },
  //{ path: 'hostgroup',component:HostgroupComponent},
  { path: 'masterresourceproperties', component: MstresourcepropertiesComponent},
  { path: 'master', component: MasterComponent},
  { path: 'blueprintform', component: MstblueprintComponent},
  { path: 'blueprintdetails', component: MstblueprintdetailsComponent},
  { path: 'blueprintresource', component: MstbluepritresourceComponent},
  { path: 'blueprinttab', component: MstblueprinttabComponent},
  //{ path: 'playbooktab', component: MstplaybooktabComponent},
  //{ path: 'playbookproperties', component: MstplaybookpropertiesComponent},
  //{ path: 'configrole', component:MstconfigrolesComponent},
  //{ path: 'adminsubscription',component:AdminsubscriptionComponent},
  //{ path: 'adminserviceprinciple',component:AdminserviceprincipleComponent},
 // { path: 'adminresourcegroup',component:AdminresourcegroupComponent},
  { path: 'masterdataresourceproperties',component:MstdataresourcepropertiesComponent},
];

const isIframe = window !== window.parent && !window.opener;

@NgModule({
  declarations: [],
  imports: [
    RouterModule.forRoot(
      appRoutes,
      { enableTracing: true,
        initialNavigation: !isIframe ? 'enabled' : 'disabled' // Don't perform initial navigation in iframes
       }
    )
  ],
  exports: [
    RouterModule
  ]
})
export class AppRoutingModule { }
