import { HttpClientModule } from '@angular/common/http';
import { APP_INITIALIZER, NgModule, inject } from '@angular/core';
import { MatAutocompleteModule } from '@angular/material/autocomplete';
import { MatProgressSpinnerModule } from '@angular/material/progress-spinner';
import { BrowserModule } from '@angular/platform-browser';
import { BrowserAnimationsModule } from '@angular/platform-browser/animations';
import { JsonFormsModule } from '@jsonforms/angular';
import { JsonFormsAngularMaterialModule } from '@jsonforms/angular-material';
import { AppComponent } from './app.component';
import { CustomAutocompleteControlRenderer } from './custom.autocomplete';
import { DataDisplayComponent } from './data.control';
import { LangComponent } from './lang.control';
import { MatMenuModule } from '@angular/material/menu';
import { AppRoutingModule } from './app-routing.module';
import { MatSelectModule } from '@angular/material/select';
import { MatButtonModule } from '@angular/material/button';
import { MatFormFieldModule } from '@angular/material/form-field';
import { MatTableModule } from '@angular/material/table';
import { MatIconModule } from '@angular/material/icon';
import { MatDialogModule, MatDialogRef } from '@angular/material/dialog';
import { MatInputModule } from '@angular/material/input';
import { MatCardModule } from '@angular/material/card';
import { MatToolbarModule} from  '@angular/material/toolbar';
import { LoginComponent } from './login/login.component';
import { RecentProjectsComponent } from './recentprojects/recentprojects.component';
import { RecentDeploymentsComponent } from './recentdeployments/recentdeployments.component';
import { DashboardComponent } from './dashboard/dashboard.component';
import { MatTabsModule } from '@angular/material/tabs';
import { HomeComponent } from './home/home.component';
import { ToastrModule } from 'ngx-toastr';
import { HeaderComponent } from './header/header.component';
import { FooterComponent } from './footer/footer.component';
import { LeftnavmenuComponent } from './leftnavmenu/leftnavmenu.component';
import { SecondaryDataDisplayComponent } from './secondarydata.control';
import { TreeModule } from '@circlon/angular-tree-component';
import { WelcomeComponent } from './welcome/welcome.component';
import appsettings from 'src/assets/app.settings.json';
import { Observable } from 'rxjs';
const isIE = window.navigator.userAgent.indexOf('MSIE ') > -1 || window.navigator.userAgent.indexOf('Trident/') > -1;

// export function configIntializer(config: ConfigService, msalBroadcastService: MsalBroadcastService, authService: MsalService): () => Observable<any> {
//   return () => {
//     return new Observable<any>((observer) => {

//       // Load configuration data needed for authentication
//       config.loadConfig().then(() => {

//         // Check if there is a stored access token
//         let token = localStorage.getItem("azapToken");
//         if (token) {

//           // If there is a token complete the observer
//           observer.next(true);
//           observer.complete();
//         } else {

//           // If there is no token, check if there are any accounts stored in the MsalService instance
//           let accounts = authService.instance.getAllAccounts();
//           if (accounts.length == 0) {

//             // If there are no accounts, subscribe to the MsalBroadcastService to listen for authentication events
//             msalBroadcastService.msalSubject$.subscribe((e) => {
//               console.log(e);
//               if (e) {

//                 // When an authentication event is called, acquire a new access token throuth config.getToken()
//                 config.getToken().subscribe(() => {

//                   // Once the token is acquired complete the observer
//                   observer.next(true);
//                   observer.complete();
//                 });
//               }
//             });
//           } else {

//             // If there are accounts, acquire a new access token directly through config.getToken()
//               config.getToken().subscribe(() => {

//               // Once the token is acquired complete the observer
//               observer.next(true);
//               observer.complete();
//             });
//           }
//         }
//       });
//     })
//   };
// }

@NgModule({
  declarations: [
    AppComponent,
    CustomAutocompleteControlRenderer,
    LangComponent,
    DataDisplayComponent,
    HeaderComponent,
    FooterComponent,
    LeftnavmenuComponent,
    LoginComponent,
    RecentProjectsComponent,
    RecentDeploymentsComponent,
    DashboardComponent,
    HomeComponent,
    SecondaryDataDisplayComponent,
    WelcomeComponent,
  ],
  imports: [
    BrowserModule,
    BrowserAnimationsModule,
    JsonFormsModule,
    JsonFormsAngularMaterialModule,
    MatAutocompleteModule,
    MatProgressSpinnerModule,
    HttpClientModule,
    MatMenuModule,
    AppRoutingModule,
    MatSelectModule,
    MatButtonModule,
    MatFormFieldModule,
    MatTableModule,
    MatIconModule,
    MatDialogModule,
    MatInputModule,
    MatCardModule,
    MatToolbarModule,
    MatTabsModule,
    ToastrModule.forRoot(),
    TreeModule,
    HttpClientModule
    // MsalModule.forRoot(new PublicClientApplication({
    //   auth:
    //   {
    //     clientId: appsettings.clientId,  // Application (client) ID from the app registration
    //     authority: appsettings.authority,  // The Azure cloud instance and the app's sign-in audience (tenant ID, common, organizations, or consumers)
    //     redirectUri: appsettings.redirectUri,// This is your redirect URI
    //     postLogoutRedirectUri: appsettings.redirectUri
    //   },
    //   cache:
    //   {
    //     cacheLocation: 'localStorage',
    //     storeAuthStateInCookie: isIE, // Set to true for Internet Explorer 11
    //   },
    //   system: {
    //     loggerOptions: {
    //       loggerCallback: (logLevel, message, piiEnabled) => {
    //         console.log(message);
    //       }
    //     }
    //   }
    // }),
    //   {
    //     interactionType: InteractionType.Redirect,
    //     authRequest: {
    //       scopes: ["user.read"],
    //     },
    //   },
    //   {
    //     interactionType: InteractionType.Redirect,
    //     protectedResourceMap: new Map([
    //       ["https://graph.microsoft.com/v1.0/me", ["user.read"]]
    //     ]),
    //   })
  ],
  providers: [
    // Add the following line
    { provide: MatDialogRef, useValue: {} }
  ],
  bootstrap: [AppComponent]
})
export class AppModule {}
