import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { RouterModule } from '@angular/router';
import { MsalGuard } from '@azure/msal-angular';
import { CreateprojectconfigComponent } from './project/project.component';
import { HostgroupComponent } from './hostgroup/hostgroup.component';
import { AssociationComponent } from './association/association.component';
import { PlaybookComponent } from './playbook/playbook.component';
import { ReviewconfigComponent } from './review/review.component';
import { PlaybookpropertydialogComponent } from './playbook/dialogs/playbookproperty.component';
import { DeploymentconfigComponent } from './deployment/deployment.component';
import { ProjectconfigComponent } from './projectnavigation/projectnavigation.component';
import { MatFormFieldModule } from '@angular/material/form-field';
import { JsonFormsModule } from '@jsonforms/angular';
import { JsonFormsAngularMaterialModule } from '@jsonforms/angular-material';
import { MatProgressSpinnerModule } from '@angular/material/progress-spinner';



@NgModule({
  declarations: [
    CreateprojectconfigComponent,
    HostgroupComponent,
    AssociationComponent,
    PlaybookComponent,
    ReviewconfigComponent,
    DeploymentconfigComponent,
    PlaybookpropertydialogComponent,
    ProjectconfigComponent
  ],
  imports: [
    CommonModule,
    MatFormFieldModule,
    JsonFormsModule,
    JsonFormsAngularMaterialModule,
    MatProgressSpinnerModule,
    RouterModule.forChild([
      { path: "", redirectTo: "project", pathMatch: "full" },
      { path: 'project', component:CreateprojectconfigComponent },
      { path: 'hostgroup', component:HostgroupComponent },
      { path: 'association', component:AssociationComponent },
      { path: 'playbook', component:PlaybookComponent },
      { path: 'review', component:ReviewconfigComponent },
      { path: 'deployment', component:DeploymentconfigComponent },
    ])
  ]
})
export class ConfigurationModule { }
