import { Component, OnInit } from '@angular/core';
import { MatDialog } from '@angular/material/dialog';
import { ConfigPlaybook } from '../../model/configproject.model';
import { Log } from '../../model/project.model';
import { WebapiService } from '../../service/webapi.service';
import { PlaybookpropertydialogComponent } from './dialogs/playbookproperty.component';

@Component({
  selector: 'app-playbook',
  templateUrl: './playbook.component.html',
  styleUrls: ['./playbook.component.css']
})
export class PlaybookComponent implements OnInit {
  projectId: string;
  environmentId: string;
  hostgroupid:string;
  mstresid:string;
  associationid:string;
  rolelist:ConfigPlaybook[]=[];
  errorlog: Log = new Log();
  constructor(public dialog: MatDialog,private webapiService : WebapiService) { }

  ngOnInit(): void {
    this.errorlog.application = "Azap";
    this.errorlog.modulename = "playbook - ngOnInit";
    this.errorlog.type = "Error";
try{
    this.projectId=this.webapiService._commonconfigproject.pcid;
    this.environmentId=this.webapiService._commonconfigproject.eid;
    this.hostgroupid=this.webapiService._commonconfigproject.hgid;
    this.mstresid=this.webapiService._commonconfigproject.resid;
    this.associationid = this.webapiService._commonconfigproject.configassid;
    if(this.projectId != undefined && this.projectId != "" && this.environmentId != "" && this.environmentId != undefined&& this.associationid !=undefined && this.associationid !=""){
    this.GetRoleList();
    }
  }catch (error) {
    this.errorlog.remark = error.message + "-" + error.stack;
    this.webapiService.ErrorLogfn(this.errorlog);
  }
  }
  GetRoleList(){
  this.webapiService.getrolelist(this.associationid).subscribe(res => {
    if (typeof res != 'undefined') {
      this.rolelist=res;
      this.rolelist.forEach(x=>{x.ismstplaybook = (x.rolevars==null) ? true:false;});
    }
  });
}
editrole(roleid:string,id:string,ismstplaybook:boolean){
  if(roleid!=''&&roleid!=null){
    const dialogRef = this.dialog.open(PlaybookpropertydialogComponent, {
    width: '1250px',
    data: {mstconfigroleid:roleid,associationid:this.associationid,uniqueid:id,ismstplaybook:ismstplaybook}
  });
  dialogRef.afterClosed().subscribe(result => {
    ///this.loadgrid(this.rgid);
  });
}
}

}
