import { Component, OnInit } from '@angular/core';
import { FormBuilder } from '@angular/forms';
import { ActivatedRoute, Router } from '@angular/router';
import { WebapiService } from '../../service/webapi.service';

@Component({
  selector: 'app-projectconfig',
  templateUrl: './projectnavigation.component.html',
  styleUrls: ['./projectnavigation.component.css']
})
export class ProjectconfigComponent implements OnInit {

  navLinks: any[];
  activeLinkIndex = 0;
  constructor(private apiService: WebapiService,private formbulider: FormBuilder,
    private route: ActivatedRoute, private _router: Router) {
      this.navLinks = [
      {
          label: 'Project',
          link: '/configuration/project',
          index: 0
      }, {
        label: 'Host Group',
        link: '/configuration/hostgroup',
        index: 1
    },{
          label: 'Association',
          link: '/configuration/association',
          index: 2
      }, {
          label: 'Playbook',
          link: '/configuration/playbook',
          index: 3
      },
      {
        label: 'Review & Submit',
        link: '/configuration/review',
        index: 4
    }
  ]; } 

  ngOnInit(): void {
    this._router.events.subscribe((res) => {
        this.activeLinkIndex = this.navLinks.indexOf(this.navLinks.find(tab => tab.link === '.' + this._router.url));
    });
  }
}
