import { Component, OnInit } from '@angular/core';
import { WebapiService } from '../service/webapi.service';
import { Router } from '@angular/router';
import { Log } from '../model/project.model';


//import { MsalService, MsalBroadcastService } from '@azure/msal-angular';
import { EventMessage, EventType, InteractionStatus } from '@azure/msal-browser';
import { filter } from 'rxjs/operators';
@Component({
  selector: 'app-home',
  templateUrl: './home.component.html',
  styleUrls: ['./home.component.css']
})
export class HomeComponent implements OnInit {

  templateDetails: any;
  errorlog: Log = new Log();
  loginDisplay = false;

  constructor(private webapiService: WebapiService, private _router: Router) { }

  ngOnInit(): void {
    this.errorlog.application = "Azap"; this.errorlog.type = "error";
    console.log('inside ngOninit of home component')
    this.getAllTemplates();
  }

  // setLoginDisplay() {
  //   //this.loginDisplay = this.authService.instance.getAllAccounts().length > 0;

  //   //if (this.loginDisplay)
  //     this.getAllTemplates();
  // }

  openReferenceArchitecture(imgname: string) {
    if (imgname != "") {
      $('.imgrefarchitect').attr('src', '../../assets/images/architectimages/' + imgname);
    }
    else {
      $('.imgrefarchitect').attr('src', '../../assets/images/notfound.png');
    }
    $('#RefernceArcitectModal').modal('show');
  }

  getAllTemplates() {
    
    try {
      console.log('inside getAllTemplates')
      this.errorlog.modulename = "RecentProjects - loadRecentProjects";
      this.templateDetails = [];
      this.webapiService.getPopularTemplates().subscribe(res => {
        if (typeof res != 'undefined' && res.length > 0) {
          this.templateDetails = res;
        }
      });
    }
    catch (error) {
      // this.errorlog.remark = error;
      // this.webapiService.ErrorLogfn(this.errorlog);
    }
  }

  displayTemplateBlock(index: number) {
    if (index % 2 === 0)
      return true;
    else
      return false;
  }

  createproject(templateId: string) {
    this.webapiService._createProjectfromTemplate.initiateRequest = true;
    this.webapiService._createProjectfromTemplate.templateId = templateId;
    this._router.navigateByUrl('/infrastructure/project');
  }

  // substringvalue(value: string) {
  //   try {
  //     if (value != undefined && value != '') {
  //       if (value.length < 60) { return value; }
  //       else {
  //         return value.substring(0, 60) + '...';
  //       }
  //     }
  //   }
  //   catch (error) {
  //     // this.errorlog.remark = error;
  //     // this.webapiService.ErrorLogfn(this.errorlog);
  //   }
  // }
}
