import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { RouterModule } from '@angular/router';
import { MsalGuard } from '@azure/msal-angular';
import { MatAutocompleteModule } from '@angular/material/autocomplete';
import { MatProgressSpinnerModule } from '@angular/material/progress-spinner';
import { TreeModule } from '@circlon/angular-tree-component';
import { TemplateComponent } from './blueprints/blueprints.component';
import { InfrareviewComponent } from './review/review.component';
import { CreateProjectComponent } from './project/project.component';
import { ResourcegroupComponent } from './resourcegroup/resourcegroup.component';
import { EnvironmentComponent } from './environment/environment.component';
import { ResourcesComponent } from './resources/resources.component';
import { DeploymentComponent } from './deployment/deployment.component';
import { ProjectComponent } from './projectnavigation/projectnavigation.component';
import { ResourcegroupExportComponent } from './resourcegroup/dialogs/resourcegroupexport.component';
import { ResourcesDialogComponent } from './resources/dialogs/resourceschema.component';
import { ProjectExportDialogComponent } from './project/dialogs/projectexport.component';
import { ResourcePreexistingDialogComponent } from './resources/dialogs/existingresourceschema.component';
import { MatFormFieldModule } from '@angular/material/form-field';
import { JsonFormsModule } from '@jsonforms/angular';
import { JsonFormsAngularMaterialModule } from '@jsonforms/angular-material';
import { MatMenuModule } from '@angular/material/menu';
import { MatSelectModule } from '@angular/material/select';
import { MatButtonModule } from '@angular/material/button';
import { MatTableModule } from '@angular/material/table';
import { MatIconModule } from '@angular/material/icon';
import { MatDialogModule  } from '@angular/material/dialog';
import { MatInputModule } from '@angular/material/input';
import { MatCardModule } from '@angular/material/card';
import { MatToolbarModule} from  '@angular/material/toolbar';

@NgModule({
  declarations: [
    TemplateComponent,
    InfrareviewComponent,
    CreateProjectComponent,
    ResourcegroupComponent,
    EnvironmentComponent,
    ResourcesComponent,
    ProjectComponent,
    ResourcegroupExportComponent,
    ProjectExportDialogComponent,
    ResourcesDialogComponent,
    ResourcePreexistingDialogComponent,
    DeploymentComponent
  ],
  imports: [
    CommonModule,
    MatFormFieldModule,
    JsonFormsModule,
    JsonFormsAngularMaterialModule,
    MatProgressSpinnerModule,
    MatMenuModule,
    MatSelectModule,
    MatButtonModule,
    MatTableModule,
    MatIconModule,
    MatDialogModule,
    MatInputModule,
    MatCardModule,
    MatToolbarModule,
    MatAutocompleteModule,
    MatProgressSpinnerModule,
    RouterModule,
    TreeModule,
    RouterModule.forChild([
      { path: "", redirectTo: "project", pathMatch: "full" },
      { path: 'blueprint', component:TemplateComponent } ,
      { path: 'project', component:CreateProjectComponent },
      { path: 'environment', component:EnvironmentComponent } ,
      { path: 'resourcegroup', component:ResourcegroupComponent },
      { path: 'resources', component:ResourcesComponent },
      { path: 'review', component:InfrareviewComponent },
      { path: 'deployment', component:DeploymentComponent },     
    ]) 
  ]
})
export class InfrastructureModule { }
