import { Component, OnInit, Input  } from '@angular/core';
import { WebapiService } from '../../service/webapi.service';
import { FormBuilder, Validators } from '@angular/forms'; 
import { Observable } from 'rxjs';
import { Project, projectEnvironment, replicateEnvironment, deleteEnvironment, EnvironmentDetails,Environment } from '../../model/project.model'
import { ActivatedRoute, Router } from '@angular/router';
import { stringify } from 'querystring';
import { RouterModule, Routes } from '@angular/router';
@Component({
  selector: 'app-projectnavigation',
  templateUrl: './projectnavigation.component.html',
  styleUrls: ['./projectnavigation.component.css']
})

export class ProjectComponent implements OnInit {
  navLinks: any[];
  activeLinkIndex = 0;
  constructor(private apiService: WebapiService,private formbulider: FormBuilder,
    private route: ActivatedRoute, private _router: Router) {
      this.navLinks = [
      {
          label: 'Project',
          link: '/infrastructure/project',
          index: 0
      }, {
          label: 'Environment',
          link: '/infrastructure/environment',
          index: 1
      }, {
          label: 'Resource Group',
          link: '/infrastructure/resourcegroup',
          index: 2
      },
      {
        label: 'Resources',
        link: '/infrastructure/resources',
        index: 3
    },
    {
      label: 'Review & Submit',
      link: '/infrastructure/review',
      index: 4
  }
  ]; }

  ngOnInit(): void {
    this._router.events.subscribe((res) => {
        this.activeLinkIndex = this.navLinks.indexOf(this.navLinks.find(tab => tab.link === '.' + this._router.url));
    });
  }
  
}