import { HttpClient } from '@angular/common/http';
import { Component, Inject, OnInit } from '@angular/core';
import { MatDialogRef, MAT_DIALOG_DATA } from '@angular/material/dialog';
import { ToastrService } from 'ngx-toastr';
import { Log } from 'src/app/model/project.model';
import { CreateResource } from 'src/app/model/resourcegroup.model';
import { WebapiService } from 'src/app/service/webapi.service';

@Component({
  selector: 'app-existingresourceschema',
  templateUrl: './existingresourceschema.component.html',
  styleUrls: ['./existingresourceschema.component.css']
})
export class ResourcePreexistingDialogComponent implements OnInit {
  resourcegroupname = 'resourcegroupname'
  regid: string
  dynamicArray = [];
  resourcesList: any;
  resourceName: string
  errorlog: Log = new Log();
  srNo = []
  resid: any
  properties: any
  uniqId: any
  constructor(public dialogRef: MatDialogRef<ResourcePreexistingDialogComponent>,
    @Inject(MAT_DIALOG_DATA) public data: any,
    private http: HttpClient, public apiService: WebapiService, private toastr: ToastrService) {
    this.resourcegroupname = data.resourcegroupname;
    this.regid = data.rgid;
    this.resid = data.resid;
    this.properties = data.properties;
    this.uniqId=data.uniqId;

  }

  ngOnInit(): void {
    if (this.properties == null) {
      this.dynamicArray.push({ name: 'resource_group_name', value: this.resourcegroupname });
      this.dynamicArray.push({ name: 'name', value: '' });
    }
    else {     
      for (const [key, value] of Object.entries(this.properties)) {

        let temp = {
          name: `${key}`,
          value: `${value}`
        }
          this.dynamicArray.push(temp)
      }
      this.dynamicArray[0].value=this.resourcegroupname;
    }
  }
  onKeyupEventName(name: string, index: any) {
    this.dynamicArray[index].name = name
  }
  onKeyupEventValue(value: string, index: any) {
    this.dynamicArray[index].value = value
  }
  saveDetails() {
    this.CreateResource_new();
  }

  CreateResource_new() {
    let sendPropertiesArray = {};
    let jsondataasstring: string;
    for (let i = 0; i < this.dynamicArray.length; i++) {
      if(this.dynamicArray[i].name!=undefined && this.dynamicArray[i].name!="" && this.dynamicArray[i].value!=undefined && this.dynamicArray[i].value!="")
      sendPropertiesArray[this.dynamicArray[i].name] = this.dynamicArray[i].value;
    }
    jsondataasstring = JSON.stringify(sendPropertiesArray);
    let sendarray = [];
    sendarray.push(JSON.parse(jsondataasstring))

    let currentResource = new CreateResource();
    currentResource.mstresourceid = this.resid;
    currentResource.properties = sendarray[0];
    currentResource.resourcegrpid = this.regid;
    currentResource.preexisting = true;
    currentResource.createdby = localStorage.getItem("azapUserEmail");
    currentResource.updatedby = localStorage.getItem("azapUserEmail");
    currentResource.reference = [];

    if(this.properties==null){
    this.apiService
      .saveResourcesJson(JSON.stringify(currentResource), 0)
      .subscribe((res) => {
        currentResource._id = res._id;
        this.toastr.success("Project details saved successfully!", "Create Project");
        this.onNoClick();
      },
        (error) => {
          this.errorlog.remark = error;
          this.apiService.ErrorLogfn(this.errorlog);
          this.onNoClick();
        })
      }
      else{
        currentResource._id=this.uniqId
        this.apiService
        .UpdateResourcesJson(JSON.stringify(currentResource))
        .subscribe((res) => {
          currentResource._id = res._id;
          this.toastr.success("Project details saved successfully!", "Create Project");
          this.onNoClick();
        },
          (error) => {
            this.errorlog.remark = error;
            this.apiService.ErrorLogfn(this.errorlog);
            this.onNoClick();
          })
      }
  }
  onNoClick(): void {
    this.dialogRef.close();
  }
  onAddClick() {

    this.dynamicArray.push({ name: '', value: '' });
  }
}
