
export class ConfigHostGroup {
    _id: string;
    configprojectid:string;
    hostgroupname: string;
    resourcetype: string;
    inventory: Inventory;
    resourcegrpid:string;
    mstresourceid:string;
    vnetpeering: vnetpeering;
    createdby: string;
    updatedby: string;
    
}
export class Inventory {
    ipaddress: IpAddress[];
}
export class IpAddress {
    terraformuniquename: string;
    address:string;
}
export class MstRole {
    _id: string;
    description:string;
    mstiacid: string;
    userreadablename: string;
    versionno: string;
    rolename:string;
    ansibleregistrypath:string;
    mstresourceid:string;
    isrequired:boolean;
}
export class ConfigAssociation {
    _id: string;
    hostgroupid:string;
    name: string;
    rolelist:ConfigRoles[];
    roles:string[];
    createdby: string;
    updatedby: string;
}
export class ConfigPlaybook {
    _id: string;
    configassociationid:string;
    mstconfigroleid: string;
    rolevars:any;
    rolename:string;
    ismstplaybook:boolean;
    createdby:string;
    updatedby: string;
}
export class ConfigRoles {
    id: string;
    rolename:string;
    associationid:string;
}
export class playbookipproperty
{
    name:string;
    type:string;
    required:string;
    argumenttype:string;
    userreadablename:string;
    defaultdeploymentvalue:string;
    regexpattern:string;
    isrequired:boolean;
    isdefault:boolean;
    description:string;
}

export class vnetpeering
{
    ip_ansible_controller_rg: string;
    ip_ansible_controller_vnet: string;
    ip_target_resource_group: string;
    ip_target_vnets: string[];
}

export class MstConfigRoles{
    _id: string;
    rolename: string;
    description: string;
    mstiacid: string;
    versionno: string;
    userreadablename: string;
    ansibleregistrypath: string;
    createdby: string;
    createdon: string;
    updatedby: string;
    updatedon: string;
    isdeleted: boolean;
    mstresourceid: string[];
    isrequired: boolean;
}

export class MstPlaybookIPProperties {
    _id: string;
    name: string;
    type: string;
    description: string;
    required: string;
    argumenttype: string;
    parentargumentid: string;
    userreadablename: string;
    defaultdeploymentvalue: string;
    defaultvalue: string[];
}

export class MstPlaybookOPProperties {
    _id: string;
    name: string;
    defaultvalue: string[];
    attributetype: string;
    parentattributeid: string;
    description: string;
    userreadablename: string;
}

export class MSTPlayBookProperties {
    _id: string;
    mstconfigroleid: string;
    ipvariables: MstPlaybookIPProperties[];
    opvariables: MstPlaybookOPProperties[];
    createdby: string;
    createdon: string;
    updatedby: string;
    updatedon: string;
    isdeleted: boolean;
}

export class CommonMstConfigRole {
    mstconfigroleid: string;
}