export class Mstresource {
    _id: string;
    modulename: string;
    description: string;
    resourcename: string;
    versionno: string;
    userreadablename: string;
    terraformregistrypath: string;
    providerid: string;
    createdby: string;
    createdon: string;
    updatedby: string;
    updatedon: string;
    isdeleted: boolean;
    isconfigurable: boolean;
}

export class MstIACProviders {
    _id: string;
    cloudprovidername: string;
    providername: string;
    mstiacid: string;
    createdby: string;
    createdon: string;
    updatedby: string;
    updatedon: string;
    isdeleted: boolean;
}

export class Mstiacs {
    _id: string;
    iactoolname: string;
}

export class MSTIPProperties {
    _id: string;
    name: string;
    type: string;
    description: string;
    required: string;
    argumenttype: string;
    parentargumentid: string;
    userreadablename: string;
    defaultdeploymentvalue: string;
    defaultvalue: string[];
    rule: string;
    validationpattern: string;
}

export class MSTOPProperties {
    _id: string;
    name: string;
    defaultvalue: string[];
    attributetype: string;
    parentattributeid: string;
    description: string;
    userreadablename: string;
}

export class MSTIPVariablesDetails {
    _id: string;
    mstresourceid: string;
    ipvariables: MSTIPProperties[];
    opvariables: MSTOPProperties[];
    createdby: string;
    createdon: string;
    updatedby: string;
    updatedon: string;
    isdeleted: boolean;
}

export class MSTOPVariablesDetails {
    _id: string;
    mstresourceid: string;
    ipvariables: MSTIPProperties[];
    opvariables: MSTOPProperties[];
    createdby: string;
    createdon: string;
    updatedby: string;
    updatedon: string;
    isdeleted: boolean;
}

export class CommonMSTResourceDetails {
    resourceId: string;
}