import { Environment, Project } from "./project.model";
import { ResourceGroup, ResourceJsonTemplateDetails } from "./resourcegroup.model";

export class Template {
    id: number;
    moduleName: string;
    description: string;
    versionno: string;
}

export class CreateTemplate {
    templateId: string;
    initiateRequest: boolean;
}


export class InfraTemplate {
    _id: string;
    templatename: string;
    category: string;
    description: string;
    referencearchitecture: string;
    project: Project;
    environment: Environment;
    resourcegroup: ResourceGroup[];
    resources: ResourceJsonTemplateDetails[];
}

export class ProjectDeploymentDetails {
    projectname: string;
    projectid: string;
    environmentdetails: EnvironmentDeploymentDetails[];
}

export class EnvironmentDeploymentDetails {
    environmentname: string;
    packagename: string;
    environmentid: string;
    packageid: string;
}

// export class DeployDetails {
//     deployProjectDetails: DeployProjectDetails[];
// }
// export class DeployProjectDetails {
//     projectname: string;
//     packageDetails: ProjectEnvironmentDeployDetails[];
// }

// export class ProjectEnvironmentDeployDetails {
//     environmentName: string;
//     deployStatus: string;
//     envId: string;
//     envName: string;
//     packageName: string;
//     packageStatus: string;
//     projectId: string;
//     projectName: string;
//     rollbackStatus: string;
//     validateStatus: string;

// }

export class DeploymentDetails {
    projectid: string;
    name: string;
    environmentid: string;
    environmentname: string;
    nugetpackageid: string;
    nugetpackagename: string;
    projectstatus: string;
    // validatestatus: string;
    // deploystatus: string;
    // rollbackstatus: string;
}

export class DeployAnsiblePackage {
    packageName: string;
    environment: string;
}

export class MSTBluePrint {
    _id: string;
    templatename: string;
    category: string;
    description: string;
    referencearchitecture: string;
    mstiacid: string;
    mstiacproviderids: string[];
    project: Project;
    environment: Environment;
    resourcegroup: blueprintrg[];
    isactive: boolean;
    createdby: string;
    updatedby: string;
}

export class blueprintrg {
    name: string;
    tags: string;
    subscription: string;
    location: string;
    resources: blueprintrgresources[];
}

export class blueprintrgresources {
    mstresourceid: string;
    //resourcename: string;
}

export class blueprintrgUI {
    name: string;
    tags: string;
    subscription: string;
    location: string;
    resources: blueprintrgresourcesUI[];
}

export class blueprintrgresourcesUI {
    mstresourceid: string;
    resourcename: string;
}

export class BlueprintId {
    blueprintid: string;
}