import { Component, OnInit } from '@angular/core';
import { WebapiService } from '../service/webapi.service';
import { Log } from '../model/project.model';

@Component({
  selector: 'app-recentdeployments',
  templateUrl: './recentdeployments.component.html',
  styleUrls: ['./recentdeployments.component.css']
})
export class RecentDeploymentsComponent implements OnInit {

  recentdeploymentDisplayColumns: string[] = ['Id', 'position', 'Name', 'View'];
  recentdeploymentDataSource: any;
  errorlog: Log = new Log();

  constructor(private webapiService: WebapiService) { }

  ngOnInit(): void {
    this.loadRecentDeployments();
  }

  loadRecentDeployments() {
    try {
      this.errorlog.application = "Azap"; this.errorlog.type = "error";
      this.errorlog.modulename = "RecentDeployments - loadRecentDeployments";
      this.recentdeploymentDataSource = [];
      this.webapiService.getProjects().subscribe(res => {
        if (typeof res != 'undefined' && res.length > 0) {
          this.recentdeploymentDataSource = res;
        }
      }, (error) => {
        this.errorlog.remark = error;
        this.webapiService.ErrorLogfn(this.errorlog);
      });
    }
    catch (error) {
      this.errorlog.remark = error;
      this.webapiService.ErrorLogfn(this.errorlog);
    }
  }

}
